﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using UP_Avalonia.ViewModels;

namespace UP_Avalonia.Models
{
    public partial class Hotel
    {
        public Hotel()
        {
            HotelComments = new HashSet<HotelComment>();
            HotelImages = new HashSet<HotelImage>();
            HotelOfTours = new HashSet<HotelOfTour>();
        }

        public int Id { get; set; }
        public string Name { get; set; } = null!;
        public int CountOfStars { get; set; }
        public string CountryCode { get; set; } = null!;
        public string? Description { get; set; }

        public virtual Country CountryCodeNavigation { get; set; } = null!;
        public virtual ICollection<HotelComment> HotelComments { get; set; }
        public virtual ICollection<HotelImage> HotelImages { get; set; }
        public virtual ICollection<HotelOfTour> HotelOfTours { get; set; }

        public string StarString
        {
            get
            {
                switch (CountOfStars)
                {
                    case 1:
                        return "★☆☆☆☆";
                    case 2:
                        return "★★☆☆☆";
                    case 3:
                        return "★★★☆☆";
                    case 4:
                        return "★★★★☆";
                    case 5:
                        return "★★★★★";
                    default:
                        break;
                }
                return "☆☆☆☆☆";
            }
        }
        public string CountryHotel
        {
            get
            {
                foreach (var i in MainWindowViewModel.myConnection.Countries)
                {
                    if (i.Code == CountryCode)
                        return i.Name;
                }

                return "Нет страны";
            }
        }
        public int CountTour
        {
            get
            {
                return 0;
            }
        }
    }
}