﻿using Avalonia.Media.Imaging;
using Avalonia.Media;
using System;
using System.Collections.Generic;

namespace UP_Avalonia.Models
{
    public partial class Tour
    {
        public Tour()
        {
            HotelOfTours = new HashSet<HotelOfTour>();
            TypeOfTours = new HashSet<TypeOfTour>();
        }

        public int Id { get; set; }
        public int TicketCount { get; set; }
        public string Name { get; set; } = null!;
        public string? Desription { get; set; }
        public string? ImagePreview { get; set; }
        public decimal Price { get; set; }
        public int IsActual { get; set; }

        public virtual ICollection<HotelOfTour> HotelOfTours { get; set; }
        public virtual ICollection<TypeOfTour> TypeOfTours { get; set; }

        public String ActualText
        {
            get
            {
                if (IsActual == 1)
                    return "Актуален";
                else
                    return "Не актуален";
            }
        }
        public SolidColorBrush ActualColor
        {
            get
            {
                if (IsActual == 1)
                    return new SolidColorBrush(Colors.Green);
                else
                    return new SolidColorBrush(Colors.Red);

            }
        }
        public Bitmap Image
        {
            get
            {
                try
                {
                    if (ImagePreview != null && ImagePreview.Length > 0)
                    {
                        string path = "Assets" + ImagePreview.Replace("/", "\\");

                        return new Bitmap(path);
                    }
                    else return new Bitmap("Assets/picture.png");
                }
                catch
                {
                    return new Bitmap("Assets/picture.png");
                }
            }
        }
    }

}