using System;
using System.Collections.Generic;
using System.Linq;
using ReactiveUI;
using UP_Avalonia.Models;

namespace UP_Avalonia.ViewModels
{
	public class NavigateToursViewModel : ReactiveObject
	{
        List<Tour> listTours = MainWindowViewModel.myConnection.Tours.ToList();
        List<String> listTypes = new List<String>() { " " };
        List<String> listSort = new List<String>() { " ", "  ", "  " };
        bool checkActual = false;
        string selectType = " ";
        string selectSort = " ";
        string search = "";
        string allPrice = " ";
        public string AllPrice { get => allPrice; set => this.RaiseAndSetIfChanged(ref allPrice, value); }
        public List<Tour> ListTours { get => listTours; set => this.RaiseAndSetIfChanged(ref listTours, value); }

        public List<String> ListTypes
        {
            get
            {
                listTypes.AddRange(MainWindowViewModel.myConnection.Types.Select(x => x.Name).ToList());
                return listTypes;
            }

        }

        public List<String> ListSort { get => listSort; }
        public string SelectType { get => selectType; set { this.RaiseAndSetIfChanged(ref selectType, value); filter(); } }
        public string SelectSort { get => selectSort; set { this.RaiseAndSetIfChanged(ref selectSort, value); filter(); } }
        public bool ActualCheck { get => checkActual; set { checkActual = value; filter(); } }
        public string Search { get => search; set { search = value; filter(); } }
        private void filter()
        {
            List<Tour> tourList = MainWindowViewModel.myConnection.Tours.ToList();
            if (!string.IsNullOrWhiteSpace(Search))
                tourList = tourList.Where(tb => tb.Name.ToLower().Contains(Search.ToLower()) || tb.Desription.ToLower().Contains(Search.ToLower())).ToList();
            if (ActualCheck)
                if (SelectType != " " && SelectType != null)
                {
                    Models.Type type = MainWindowViewModel.myConnection.Types.FirstOrDefault(tb => tb.Name == SelectType);
                    List<TypeOfTour> list = MainWindowViewModel.myConnection.TypeOfTours.Where(tb => tb.TypeId == type.Id).ToList();
                    if (list.Count > 0)
                    {
                        int i = 0;
                        while (i < tourList.Count)
                        {
                            bool flag = list.FirstOrDefault(tb => tb.TourId == tourList[i].Id) != null;
                            if (!flag)
                                tourList.RemoveAt(i);
                            else
                                i++;
                        }
                    }
                    else
                        tourList.Clear();
                }

            if (selectSort == "  ")
            {
                tourList = tourList.OrderBy(tb => tb.Price).ToList();
            }
            if (selectSort == "  ")
            {
                tourList = tourList.OrderByDescending(tb => tb.Price).ToList();
            }

            ListTours = tourList;
            AllPrice = string.Format("{0:C2}", Math.Round(ListTours.Sum(tb => tb.Price * tb.TicketCount), 2));
        }
    }
}